require 'package'
class Re6stnet < Package
  description 'Resilient, Scalable, IPv6 Network'
  homepage 'https://re6st.nexedi.com/'
  version '0.551'
  compatibility 'all'
  source_url 'https://lab.nexedi.com/nexedi/chromebrew-buildout-re6st/repository/archive.tar.bz2?ref=3c2db2151ec7cc0bd2630a72178dd10e5d784f12'
  source_sha256 '2cf94c0531dcf736a7a7329750f06b38c7268ad4ea6612ec294387f3400cd53b'

  binary_url ({
    x86_64: 'https://softinst105421.host.vifib.net/public/re6stnet-0.551-chromeos-x86_64.tar.xz',
  })
  binary_sha256 ({
    x86_64: 'd161850597f0f6746b62bf2aaab7d6776cfd49e55482c73e7c3703e41f7803b7',
  })

  depends_on 'python27' => :build
  depends_on 'filecmd' => :build
  depends_on 'libiconv' => :build
  depends_on 'glibc'

  @re6st_dir = "#{CREW_PREFIX}/opt/re6st"

  def self.build
    system "mkdir -p #{@re6st_dir}/bin/ #{@re6st_dir}/tmp-networkcached/bin"
    system "cp buildout.cfg #{@re6st_dir}"
    system "cp bin/* #{@re6st_dir}/bin/"
    system "gcc shill_wrapper.c -o #{@re6st_dir}/bin/shill_wrapper -ldl -Wall -fPIC -pie"
    system "cp bin/bootstrap #{@re6st_dir}/tmp-networkcached/bin/"
    system "cp networkcached.cfg #{@re6st_dir}/tmp-networkcached/buildout.cfg"
    system "cd #{@re6st_dir}/tmp-networkcached && ./bin/bootstrap && MAKEFLAGS=-j ./bin/buildout"
    system "cd #{@re6st_dir} && MAKEFLAGS=-j SSL_CERT_DIR=/etc/ssl/certs tmp-networkcached/bin/buildout"
  end

  def self.install
    system "mkdir -p #{CREW_DEST_PREFIX}/opt/"
    system "cp -r #{@re6st_dir} #{CREW_DEST_DIR}#{@re6st_dir}"
    system "rm -rf #{CREW_DEST_DIR}#{@re6st_dir}/download-cache"
  end

  def self.postinstall
    system "ln -fs #{@re6st_dir}/bin/grandenet #{CREW_PREFIX}/sbin/grandenet"
    system "ln -fs #{@re6st_dir}/bin/shill.sh #{CREW_PREFIX}/sbin/shill.sh"
    system "ln -fs #{@re6st_dir}/bin/shill_wrapper #{CREW_PREFIX}/sbin/shill_wrapper"
    system "ln -fs #{@re6st_dir}/bin/re6stnet #{CREW_PREFIX}/sbin/re6stnet"
    system "ln -fs #{@re6st_dir}/bin/re6st-conf #{CREW_PREFIX}/bin/re6st-conf"
    system "ln -fs #{@re6st_dir}/bin/re6st-registry #{CREW_PREFIX}/bin/re6st-registry"
    puts "To initiate re6stnet, run #{CREW_PREFIX}/sbin/grandenet"
  end
end
